'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.didReplaceRoutes = exports.replaceRoutes = exports.initializeCurrentLocation = exports.locationDidChange = exports.unblock = exports.block = exports.goForward = exports.goBack = exports.go = exports.replace = exports.push = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _types = require('./types');

var _normalizeHref = require('./util/normalize-href');

var _normalizeHref2 = _interopRequireDefault(_normalizeHref);

var _flattenRoutes = require('./util/flatten-routes');

var _flattenRoutes2 = _interopRequireDefault(_flattenRoutes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var push = exports.push = function push(href) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  return {
    type: _types.PUSH,
    payload: _extends({}, (0, _normalizeHref2.default)(href), { options: options })
  };
};

var replace = exports.replace = function replace(href) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  return {
    type: _types.REPLACE,
    payload: _extends({}, (0, _normalizeHref2.default)(href), { options: options })
  };
};

var go = exports.go = function go(index) {
  return {
    type: _types.GO,
    payload: index
  };
};

var goBack = exports.goBack = function goBack() {
  return { type: _types.GO_BACK };
};
var goForward = exports.goForward = function goForward() {
  return { type: _types.GO_FORWARD };
};

var block = exports.block = function block(historyShouldBlock) {
  return {
    type: _types.BLOCK,
    payload: historyShouldBlock
  };
};

var unblock = exports.unblock = function unblock() {
  return { type: _types.UNBLOCK };
};

var locationDidChange = exports.locationDidChange = function locationDidChange(location) {
  return {
    type: _types.LOCATION_CHANGED,
    payload: location
  };
};

var initializeCurrentLocation = exports.initializeCurrentLocation = function initializeCurrentLocation(location) {
  return {
    type: _types.LOCATION_CHANGED,
    payload: location
  };
};

var replaceRoutes = exports.replaceRoutes = function replaceRoutes(routes) {
  return {
    type: _types.REPLACE_ROUTES,
    payload: {
      routes: (0, _flattenRoutes2.default)(routes),
      options: {
        updateRoutes: true
      }
    }
  };
};

var didReplaceRoutes = exports.didReplaceRoutes = function didReplaceRoutes() {
  return {
    type: _types.DID_REPLACE_ROUTES
  };
};